#
# Copyright (C) 2003 Ryan McCabe <ryan@numb.org>
#
# Works with the xmms-infopipe plugin (search google for it)
#
# Appends a line displaying what's playing in xmms to your profile every 30 seconds, and
# whenever the profile is changed.
#
# I'm a C programmer, not a Perl programmer, and it probably shows.
#

my $xmms_info = "/tmp/xmms-info"; 

sub np_init {
	PORK::event_add("SEND_PROFILE", "np_send_profile_handler");
	PORK::timer_add(30, 0, "perl np_run");
	np_run();
}

sub np_get_info {
	my $info_hash = shift;
	local *FILE;

	open(FILE, "<$xmms_info") || return (0);

	while (<FILE>) {
		my $left;
		my $right;

		($left, $right) = split(/: /, $_, 2);
		if ($left && $right) {
			chop($right);
			$info_hash->{$left} = $right;
		}
	}

	close(FILE);
	return (1);
}

sub np_run {
	my %info_hash = ();
	my $np_str = "nothing";
	my $cur_profile = PORK::aim_get_profile();

	if (np_get_info(\%info_hash)) {
		$np_str = $info_hash{'Title'};
	}

	$cur_profile .= "<BR><BR>np: $np_str";
	PORK::aim_send_profile($cur_profile);
}

sub np_send_profile_handler {
	my $profile = shift;
	my $user = shift;
	my %info_hash = ();
	my $np_str = "nothing";

	if (np_get_info(\%info_hash)) {
		$np_str = $info_hash{'Title'};
	}

	$profile .= "<BR><BR>np: $np_str";
	PORK::aim_send_profile($profile);
	return (1);
}

np_init();
